/* Globals */

#ifndef _GLOBAL_VARS_H_INCLUDED
#define _GLOBAL_VARS_H_INCLUDED

extern  memory_pool         action_pool;
extern  production        * all_productions_of_type[NUM_PRODUCTION_TYPES];
extern  wme               * all_wmes_in_rete;
extern  hash_table        *(alpha_hash_tables[16]);
extern  unsigned long       alpha_mem_id_counter;
extern  memory_pool         alpha_mem_pool;
extern  symbol            * atom_symbol;
extern  symbol            * attribute_symbol;
extern  tc_number           backtrace_number;
extern  unsigned long       beta_node_id_counter;
extern  symbol            * bottom_goal;
extern  symbol            * cc_symbol;
extern  dl_list           * changed_slots;
extern  symbol            * choices_symbol;
extern  memory_pool         chunk_cond_pool;
extern  unsigned long       chunk_count;
extern  bool                chunk_free_flag;
extern  list              * chunk_free_problem_spaces;
extern  io_wme            * collected_io_wmes;
extern  not               * collected_nots;
extern  memory_pool         complex_test_pool;
extern  memory_pool         condition_pool;
extern  symbol            * conflict_symbol;
extern  memory_pool         cons_cell_pool;
extern  symbol            * constraint_failure_symbol;
extern  dl_list           * context_slots_with_changed_acceptable_preferences;
extern  symbol            * crlf_symbol;
extern  double              cumulative_wm_size;
extern  char                current_char;
extern  lexer_source_file * current_file;
extern  enum top_level_phase current_phase;
extern  unsigned long       current_symbol_hash_id;
extern  struct text_environment current_text_environment;
extern  unsigned long       current_variable_gensym_number;
extern  unsigned long       current_wme_timetag;
extern  unsigned long       d_cycle_count;            /* # of DC's run so far */
extern  dl_list           * disconnected_ids;
extern  memory_pool         dl_cons_pool;
extern  rete_node           dummy_matches_node;
extern  token             * dummy_matches_node_tokens;
extern  rete_node           dummy_top_node;
extern  unsigned long       e_cycle_count;            /* # of EC's run so far */
extern  unsigned long       e_cycles_this_d_cycle;    /* # of EC's run this DC */
extern  output_link       * existing_output_links;
extern  preference        * extra_result_prefs_from_instantiation;
extern  struct hash_table_struct  * float_constant_hash_table;
extern  memory_pool         float_constant_pool;
extern  char              * format;
extern  char              * format_string_error_message;
extern  bool                found_undefined;   
extern  symbol            * g_context_variable;
extern  unsigned long       gensymed_variable_count[26];
extern  long                go_number;
extern  symbol            * go_slot_attr;
extern  goal_stack_level    go_slot_level;
extern  enum go_type_enum   go_type;
extern  symbol            * goal_symbol;
extern  list              * grounds;
extern  tc_number           grounds_tc;
extern  symbol            * highest_goal_whose_context_changed;
extern  goal_stack_level    highest_level_anything_could_fall_from;
extern  unsigned long       id_counter[26]; 
extern  struct hash_table_struct * identifier_hash_table;
extern  memory_pool         identifier_pool;
extern  dl_list           * ids_with_unknown_level;
extern  symbol            * impasse_symbol;
extern  int                 index_num;
extern  input_function_info * input_functions;
extern  memory_pool         instantiation_pool;
extern  list              * instantiations_with_nots;
extern  struct hash_table_struct  * int_constant_hash_table;
extern  memory_pool         int_constant_pool;
extern  char                interrupt_source[2*MAX_LEXEME_LENGTH+100];
extern  memory_pool         io_wme_pool;
extern  symbol            * item_symbol;
extern  unsigned long       justification_count;
extern  token_hash_table    left_ht;
extern  goal_stack_level    level_at_which_marking_started;
extern  struct lexeme_info  lexeme;
extern  int                 link_update_mode;
extern  list              * locals;
extern  tc_number           locals_tc;
extern  FILE              * log_file;
extern  char              * log_file_name;
extern  bool                logging_to_file;
extern  goal_stack_level    lowest_level_anything_could_fall_to;
extern  tc_number           mark_tc_number;
extern  struct timeval      match_cpu_time;
extern  unsigned long       max_wm_size;    /* maximum size of WM so far */
extern  unsigned long       mcs_counter;
extern  unsigned long       memory_for_usage[NUM_MEM_USAGE_CODES];
extern  memory_pool       * memory_pools_in_use;
extern  ms_change         * ms_assertions;
extern  memory_pool         ms_change_pool;
extern  ms_change         * ms_retractions;
extern  symbol            * multiple_symbol;
extern  char              * name;
extern  symbol            * name_symbol;
extern  node_varnames     * ncc_subconditions_bottom_dense_nvn;
extern  rete_node         * ncc_subconditions_bottom_node;
extern  node_varnames     * ncc_subconditions_bottom_sparse_nvn;
extern  memory_pool         neg_token_pool;
extern  chunk_cond_set      negated_set; 
extern  instantiation     * newly_created_instantiations;
extern  symbol            * next_symbol;
extern  symbol            * nil_symbol;
extern  symbol            * no_change_symbol;
extern  memory_pool         node_varnames_pool;
extern  symbol            * none_symbol;
extern  memory_pool         not_pool;
extern  unsigned long       num_existing_wmes;
extern  unsigned long       num_productions_of_type[NUM_PRODUCTION_TYPES];
extern  unsigned long       num_wm_sizes_accumulated; 
extern  unsigned long       num_wmes_in_rete;
extern  symbol            * o_context_variable;
extern  tc_number           o_support_tc;   
extern  symbol            * object_symbol;
extern  trace_format      *(object_tf_for_anything[5]);
extern  struct hash_table_struct *(object_tr_ht[5]);
extern  symbol            * operator_symbol;
extern  output_function_info * output_functions;
extern  output_link       * output_link_for_tc;
extern  memory_pool         output_link_pool;
extern  tc_number           output_link_tc_num;
extern  symbol            * p_context_variable;
extern  unsigned long       placeholder_counter[26];
extern  list              * positive_potentials;
extern  tc_number           potentials_tc;
extern  memory_pool         preference_pool;
extern  struct text_environment prev_text_environment;
extern  symbol            * prev_top_state;
extern  char                printed_output_string[MAX_LEXEME_LENGTH*2+10];
extern  int                 printer_output_column;
extern  bool                printing_stack_traces;
extern  symbol            * problem_space_symbol;
extern  byte                production_addition_result;
extern  production        * production_being_added_now;
extern  production        * production_being_fired;
extern  unsigned long       production_firing_count;  /* # of production firings */
extern  memory_pool         production_pool;
extern  list              * productions_being_traced; 
extern  list              * promoted_ids;
extern  symbol            * quiescence_symbol;
extern  bool                quiescence_t_flag;
extern  char              * reason_for_stopping;
extern  bool                redirecting_to_file;
extern  FILE              * redirection_file;
extern  instantiation     * refracted_inst_for_production_being_added_now;
extern  preference        * results;
extern  goal_stack_level    results_match_goal_level;
extern  tc_number           results_tc_number;
extern  unsigned long       rete_node_counts[256];
extern  memory_pool         rete_node_pool;
extern  memory_pool         rete_test_pool;
extern  preference        * rhs_prefs_from_instantiation;
extern  token_hash_table    right_ht;
extern  memory_pool         right_mem_pool;
extern  symbol            * s_context_variable;
extern  int                 saved_printer_output_column;
extern  memory_pool         saved_test_pool;
extern  symbol            * sg_context_variable;
extern  memory_pool         slot_pool;
extern  list              * slots_for_possible_removal;
extern  symbol            * so_context_variable;
extern  symbol            * sp_context_variable;
extern  symbol            * space_symbol;
extern  symbol            * ss_context_variable;
extern  symbol            * ssg_context_variable;
extern  symbol            * sso_context_variable;
extern  symbol            * ssp_context_variable;
extern  symbol            * sss_context_variable;
extern  trace_format      *(stack_tf_for_anything[5]);
extern  struct hash_table_struct *(stack_tr_ht[5]);
extern  struct timeval      start_total_tv;
extern  symbol            * state_symbol;
extern  symbol            * stdin_symbol;
extern  symbol            * stdout_symbol;
extern  bool                stop_soar;
extern  struct hash_table_struct  * sym_constant_hash_table;
extern  memory_pool         sym_constant_pool;
extern  long                sysparams[HIGHEST_SYSPARAM_NUMBER+1];
extern  bool                system_halted;
extern  symbol            * t_symbol;
extern  symbol            * te_identifier;
extern  wme               * te_input_stream_wme;
extern  wme               * te_output_stream_wme;
extern  symbol            * text_command_symbol;
extern  wme               * text_environment_link;
extern  symbol            * text_environment_symbol;
extern  wme               * text_input_link;
extern  queue             * text_input_queue;
extern  symbol            * text_input_stream_symbol;
extern  symbol            * text_input_symbol;
extern  text_io_symbol_to_file_mapping * text_io_symbol_to_file_mappings;
extern  symbol            * text_output_stream_symbol;
extern  symbol            * text_output_symbol;
extern  tc_number           tf_printing_tc;   
extern  symbol            * tg_context_variable;
extern  symbol            * tie_symbol;
extern  symbol            * to_context_variable;
extern  unsigned long       token_additions;
extern  unsigned long       token_deletions;
extern  memory_pool         token_pool;
extern  symbol            * top_goal;
extern  symbol            * top_state;
extern  struct timeval      total_cpu_time;
extern  symbol            * tp_context_variable;
extern  symbol            * ts_context_variable;
extern  symbol            * type_symbol;
extern  struct hash_table_struct * variable_hash_table;
extern  memory_pool         variable_pool;
extern  tc_number           variablization_tc;
extern  bool                variablize_this_chunk;
extern  goal_stack_level    walk_level;
extern  tc_number           walk_tc_number;
extern  bool                warn_on_duplicate_production;
extern  unsigned long       wme_addition_count;       /* # of wmes added to WM */
extern  memory_pool         wme_pool;
extern  unsigned long       wme_removal_count;      /* # of wmes removed from WM */
extern  list              * wmes_to_add;
extern  list              * wmes_to_remove;

#ifdef DETAILED_TIMING_STATS
extern  struct timeval      ownership_cpu_time;
extern  struct timeval      chunking_cpu_time;
extern  struct timeval      preference_phase_cpu_time;
extern  struct timeval      create_instantiations_cpu_time;
extern  struct timeval      o_support_cpu_time;
#endif

#endif /* _GLOBAL_VARS_H_INCLUDED */
