// machview.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMachineView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CMachineView : public CFormView
{

friend class CMachineDoc;

	DECLARE_DYNCREATE(CMachineView)
protected:
	CMachineView();			// protected constructor used by dynamic creation
	virtual BOOL Create(LPCSTR lpszClassName,
						LPCSTR lpszWindowName,
						DWORD  dwStyle,
						const RECT& rect,
						CWnd* pParentWnd,
						UINT nID,
						CCreateContext* pContext=NULL);

// Form Data
public:
	//{{AFX_DATA(CMachineView)
	enum { IDD = IDD_MACHINE };
	CListBox	m_ProductionList;
	CListBox	m_LogScroll;
	CComboBox	m_CommandCombo;
	CListBox	m_ChunkList;
	CButton	m_ExecuteButton;
	CBitmapButton	m_StepButton;
	CBitmapButton	m_RunButton;
	CBitmapButton	m_InterruptButton;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
	void SetButtonState(int);

// Implementation
protected:
	virtual ~CMachineView();
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual void OnUpdate(CView* pSender,
						  LPARAM lHint,
						  CObject *pHint);
	virtual void OnInitialUpdate();
	// Generated message map functions
	//{{AFX_MSG(CMachineView)
	afx_msg void OnClickedInterrupt();
	afx_msg void OnClickedRun();
	afx_msg void OnClickedStep();
	afx_msg void OnClickedExecute();
	afx_msg void OnDblclkSoarChunks();
	afx_msg void OnDblclkSoarProductions();
	afx_msg void OnLogSelect();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
