/*
 * $Id: global_vars.h,v 1.1 1993/06/17 20:47:16 jtraub Exp $
 * $Log: global_vars.h,v $
 * Revision 1.1  1993/06/17  20:47:16  jtraub
 * Released
 *
 * Revision 0.1  1993/06/17  20:20:15  jtraub
 * 6.1_checkin
 *
 * Revision 9.4  1993/06/01  21:13:52  jtraub
 * added path variable.
 *
 * Revision 9.3  1993/05/10  18:14:27  jtraub
 * added RCS headers
 *
 */
 
/* Globals */

#define STOP_HALT 3
#define STOP_PAUSE 2
#define STOP_INTERRUPT 1
#define STOP_NOT 0

  memory_pool         action_pool;
  production        * all_productions_of_type[NUM_PRODUCTION_TYPES];
  wme               * all_wmes_in_rete;
  hash_table        *(alpha_hash_tables[16]);
  unsigned long       alpha_mem_id_counter;
  memory_pool         alpha_mem_pool;
  Symbol            * atom_symbol;
  Symbol            * attribute_symbol;
  tc_number           backtrace_number;
  unsigned long       beta_node_id_counter;
  Symbol            * bottom_goal;
  Symbol            * cc_symbol;
  dl_list           * changed_slots;
  Symbol            * choices_symbol;
  memory_pool         chunk_cond_pool;
  unsigned long       chunk_count;
  bool                chunk_free_flag;
  list              * chunk_free_problem_spaces;
  io_wme            * collected_io_wmes;
  not               * collected_nots;
  memory_pool         complex_test_pool;
  memory_pool         condition_pool;
  Symbol            * conflict_symbol;
  memory_pool         cons_cell_pool;
  Symbol            * constraint_failure_symbol;
  dl_list           * context_slots_with_changed_acceptable_preferences;
  Symbol            * crlf_symbol;
  double              cumulative_wm_size;
  char                current_char;
  lexer_source_file * current_file;
  char 				  current_line[MAX_LEXER_LINE_LENGTH];
  int				  current_line_index;
  enum top_level_phase current_phase;
  unsigned long       current_symbol_hash_id;
  struct text_environment current_text_environment;
  unsigned long       current_variable_gensym_number;
  unsigned long       current_wme_timetag;
  unsigned long       d_cycle_count;            /* # of DC's run so far */
  dl_list           * disconnected_ids;
  memory_pool         dl_cons_pool;
  rete_node           dummy_matches_node;
  token             * dummy_matches_node_tokens;
  rete_node           dummy_top_node;
  unsigned long       e_cycle_count;            /* # of EC's run so far */
  unsigned long       e_cycles_this_d_cycle;    /* # of EC's run this DC */
  output_link       * existing_output_links;
  preference        * extra_result_prefs_from_instantiation;
  struct hash_table_struct  * float_constant_hash_table;
  memory_pool         float_constant_pool;
  char              * format;
  char              * format_string_error_message;
  bool                found_undefined;   
  Symbol            * g_context_variable;
  unsigned long       gensymed_variable_count[26];
  long                go_number;
  Symbol            * go_slot_attr;
  goal_stack_level    go_slot_level;
  enum go_type_enum   go_type;
  Symbol            * goal_symbol;
  list              * grounds;
  tc_number           grounds_tc;
  Symbol            * highest_goal_whose_context_changed;
  goal_stack_level    highest_level_anything_could_fall_from;
  unsigned long       id_counter[26]; 
  struct hash_table_struct * identifier_hash_table;
  memory_pool         identifier_pool;
  dl_list           * ids_with_unknown_level;
  Symbol            * impasse_symbol;
  int                 index_num;
  input_function_info * input_functions;
  memory_pool         instantiation_pool;
  list              * instantiations_with_nots;
  struct hash_table_struct  * int_constant_hash_table;
  memory_pool         int_constant_pool;
  char                interrupt_source[2*MAX_LEXEME_LENGTH+100];
  memory_pool         io_wme_pool;
  Symbol            * item_symbol;
  unsigned long       justification_count;
  token_hash_table    left_ht;
  goal_stack_level    level_at_which_marking_started;
  struct lexeme_info  lexeme;
  int                 link_update_mode;
  list              * locals;
  tc_number           locals_tc;
  FILE              * log_file;
  char              * log_file_name;
  bool                logging_to_file;
  goal_stack_level    lowest_level_anything_could_fall_to;
  tc_number           mark_tc_number;
  unsigned long       max_wm_size;    /* maximum size of WM so far */
  unsigned long       mcs_counter;
  unsigned long       memory_for_usage[NUM_MEM_USAGE_CODES];
  memory_pool       * memory_pools_in_use;
  ms_change         * ms_assertions;
  memory_pool         ms_change_pool;
  ms_change         * ms_retractions;
  Symbol            * multiple_symbol;
  char              * name;
  Symbol            * name_symbol;
  node_varnames     * ncc_subconditions_bottom_dense_nvn;
  rete_node         * ncc_subconditions_bottom_node;
  node_varnames     * ncc_subconditions_bottom_sparse_nvn;
  memory_pool         neg_token_pool;
  chunk_cond_set      negated_set; 
  instantiation     * newly_created_instantiations;
  Symbol            * next_symbol;
  Symbol            * nil_symbol;
  Symbol            * no_change_symbol;
  memory_pool         node_varnames_pool;
  Symbol            * none_symbol;
  memory_pool         not_pool;
  unsigned long       num_existing_wmes;
  unsigned long       num_productions_of_type[NUM_PRODUCTION_TYPES];
  unsigned long       num_wm_sizes_accumulated; 
  unsigned long       num_wmes_in_rete;
  Symbol            * o_context_variable;
  tc_number           o_support_tc;   
  Symbol            * object_symbol;
  trace_format      *(object_tf_for_anything[5]);
  struct hash_table_struct *(object_tr_ht[5]);
  Symbol            * operator_symbol;
  output_function_info * output_functions;
  output_link       * output_link_for_tc;
  memory_pool         output_link_pool;
  tc_number           output_link_tc_num;
  Symbol            * p_context_variable;
  unsigned long       placeholder_counter[26];
  list              * positive_potentials;
  tc_number           potentials_tc;
  memory_pool         preference_pool;
  struct text_environment prev_text_environment;
  Symbol            * prev_top_state;
  char                printed_output_string[MAX_LEXEME_LENGTH*2+10];
  int                 printer_output_column;
  bool                printing_stack_traces;
  Symbol            * problem_space_symbol;
  byte                production_addition_result;
  production        * production_being_added_now;
  production        * production_being_fired;
  unsigned long       production_firing_count;  /* # of production firings */
  memory_pool         production_pool;
  list              * productions_being_traced; 
  list              * promoted_ids;
  Symbol            * quiescence_symbol;
  bool                quiescence_t_flag;
  char              * reason_for_stopping;
  bool                redirecting_to_file;
  FILE              * redirection_file;
  instantiation     * refracted_inst_for_production_being_added_now;
  preference        * results;
  goal_stack_level    results_match_goal_level;
  tc_number           results_tc_number;
  unsigned long       rete_node_counts[256];
  memory_pool         rete_node_pool;
  memory_pool         rete_test_pool;
  preference        * rhs_prefs_from_instantiation;
  token_hash_table    right_ht;
  memory_pool         right_mem_pool;
  Symbol            * s_context_variable;
  int                 saved_printer_output_column;
  memory_pool         saved_test_pool;
  Symbol            * sg_context_variable;
  memory_pool         slot_pool;
  list              * slots_for_possible_removal;
  Symbol            * so_context_variable;
  Symbol            * sp_context_variable;
  Symbol            * space_symbol;
  Symbol            * ss_context_variable;
  Symbol            * ssg_context_variable;
  Symbol            * sso_context_variable;
  Symbol            * ssp_context_variable;
  Symbol            * sss_context_variable;
  trace_format      *(stack_tf_for_anything[5]);
  struct hash_table_struct *(stack_tr_ht[5]);
  Symbol            * state_symbol;
  Symbol            * stdin_symbol;
  Symbol            * stdout_symbol;
  bool                stop_soar;
  struct hash_table_struct  * sym_constant_hash_table;
  memory_pool         sym_constant_pool;
  long                sysparams[HIGHEST_SYSPARAM_NUMBER+1];
  bool                system_halted;
  Symbol            * t_symbol;
  tc_number           tf_printing_tc;   
  Symbol            * tg_context_variable;
  Symbol            * tie_symbol;
  Symbol            * to_context_variable;
  unsigned long       token_additions;
  unsigned long       token_deletions;
  memory_pool         token_pool;
  Symbol            * top_goal;
  Symbol            * top_state;
  Symbol            * tp_context_variable;
  Symbol            * ts_context_variable;
  Symbol            * type_symbol;
  struct hash_table_struct * variable_hash_table;
  memory_pool         variable_pool;
  tc_number           variablization_tc;
  bool                variablize_this_chunk;
  goal_stack_level    walk_level;
  tc_number           walk_tc_number;
  bool                warn_on_duplicate_production;
  unsigned long       wme_addition_count;       /* # of wmes added to WM */
  memory_pool         wme_pool;
  unsigned long       wme_removal_count;      /* # of wmes removed from WM */
  list              * wmes_to_add;
  list              * wmes_to_remove;
  multi_attribute   * multi_attributes;
  char                path[1000];

#ifdef DETAILED_TIMING_STATS
  struct timeval      ownership_cpu_time;
  struct timeval      chunking_cpu_time;
  struct timeval      preference_phase_cpu_time;
  struct timeval      create_instantiations_cpu_time;
  struct timeval      o_support_cpu_time;
#endif

#ifndef NO_TIMING_STUFF
  struct timeval      match_cpu_time;
  struct timeval      start_total_tv;
  struct timeval      total_cpu_time;
#endif

#ifdef _WINDOWS
  bool				  redirecting_to_string;
  char				* redirected_string;
#endif
