// watchdlg.cpp : implementation file
//

#include "stdafx.h"
#include "soar.h"
#include "watchdlg.h"
#include "src/soar.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWatchDialog dialog

CWatchDialog::CWatchDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CWatchDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWatchDialog)
	m_Backtraces = FALSE;
	m_ChunkBody = FALSE;
	m_ChunkName = FALSE;
	m_Context = FALSE;
	m_Firings = FALSE;
	m_JustificationBody = FALSE;
	m_JustificationName = FALSE;
	m_Phases = FALSE;
	m_WMEs = FALSE;
	m_FireChunks = FALSE;
	m_FireDefault = FALSE;
	m_FireJustifications = FALSE;
	m_FireUser = FALSE;
	m_FireWme = FALSE;
	m_FirePref = FALSE;
	//}}AFX_DATA_INIT
}

void CWatchDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWatchDialog)
	DDX_Control(pDX, IDC_FIRE_WME, m_FireWmeButton);
	DDX_Control(pDX, IDC_FIRE_USER, m_FireUserButton);
	DDX_Control(pDX, IDC_FIRE_PREF, m_FirePrefButton);
	DDX_Control(pDX, IDC_WME, m_WMEsButton);
	DDX_Control(pDX, IDC_PHASES, m_PhasesButton);
	DDX_Control(pDX, IDC_FIRE_DEFAULT, m_FireDefaultButton);
	DDX_Control(pDX, IDC_CONTEXT, m_ContextButton);
	DDX_Control(pDX, IDC_WATCH_LEVELS, m_WatchControl);
	DDX_Check(pDX, IDC_BACKTRACES, m_Backtraces);
	DDX_Check(pDX, IDC_CHUNK_BODY, m_ChunkBody);
	DDX_Check(pDX, IDC_CHUNK_NAME, m_ChunkName);
	DDX_Check(pDX, IDC_CONTEXT, m_Context);
	DDX_Check(pDX, IDC_FRINGS, m_Firings);
	DDX_Check(pDX, IDC_JUSTIFICATION_BODY, m_JustificationBody);
	DDX_Check(pDX, IDC_JUSTIFICATION_NAME, m_JustificationName);
	DDX_Check(pDX, IDC_PHASES, m_Phases);
	DDX_Check(pDX, IDC_WME, m_WMEs);
	DDX_Check(pDX, IDC_FIRE_CHUNKS, m_FireChunks);
	DDX_Check(pDX, IDC_FIRE_DEFAULT, m_FireDefault);
	DDX_Check(pDX, IDC_FIRE_JUSTIFICATIONS, m_FireJustifications);
	DDX_Check(pDX, IDC_FIRE_USER, m_FireUser);
	DDX_Check(pDX, IDC_FIRE_WME, m_FireWme);
	DDX_Check(pDX, IDC_FIRE_PREF, m_FirePref);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWatchDialog, CDialog)
	//{{AFX_MSG_MAP(CWatchDialog)
	ON_CBN_SELENDOK(IDC_WATCH_LEVELS, OnWatchSelected)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWatchDialog message handlers

void CWatchDialog::OnWatchSelected()
{
	switch (m_WatchControl.GetCurSel()) {
	  case 0:	// -1
	  	m_ContextButton.SetCheck(0);
	  	m_PhasesButton.SetCheck(0);
	  	m_FireDefaultButton.SetCheck(0);
	  	m_FireUserButton.SetCheck(0);
	  	m_FireWmeButton.SetCheck(0);
	  	m_FirePrefButton.SetCheck(0);
	  	m_WMEsButton.SetCheck(0);
	  	break;
	  case 1:  // 0
	  	m_ContextButton.SetCheck(1);
	  	m_PhasesButton.SetCheck(0);
	  	m_FireDefaultButton.SetCheck(0);
	  	m_FireUserButton.SetCheck(0);
	  	m_FireWmeButton.SetCheck(0);
	  	m_FirePrefButton.SetCheck(0);
	  	m_WMEsButton.SetCheck(0);
	  	break;
	 case 2: // 0.5
	  	m_ContextButton.SetCheck(1);
	  	m_PhasesButton.SetCheck(1);
	  	m_FireDefaultButton.SetCheck(1);
	  	m_FireUserButton.SetCheck(1);
	  	m_FireWmeButton.SetCheck(0);
	  	m_FirePrefButton.SetCheck(0);
	  	m_WMEsButton.SetCheck(0);
	  	break;
	  case 3: // 1
	  	m_ContextButton.SetCheck(1);
	  	m_PhasesButton.SetCheck(1);
	  	m_FireDefaultButton.SetCheck(1);
	  	m_FireUserButton.SetCheck(1);
	  	m_FireWmeButton.SetCheck(1);
	  	m_FirePrefButton.SetCheck(0);
	  	m_WMEsButton.SetCheck(0);
	  	break;
	 case 4: // 1.5
	  	m_ContextButton.SetCheck(1);
	  	m_PhasesButton.SetCheck(1);
	  	m_FireDefaultButton.SetCheck(1);
	  	m_FireUserButton.SetCheck(1);
	  	m_FireWmeButton.SetCheck(1);
	  	m_FirePrefButton.SetCheck(0);
	  	m_WMEsButton.SetCheck(0);
	  	break;
	 case 5: // 2
	  	m_ContextButton.SetCheck(1);
	  	m_PhasesButton.SetCheck(1);
	  	m_FireDefaultButton.SetCheck(1);
	  	m_FireUserButton.SetCheck(1);
	  	m_FireWmeButton.SetCheck(1);
	  	m_FirePrefButton.SetCheck(0);
	  	m_WMEsButton.SetCheck(1);
	  	break;
	 case 6: // 3
	  	m_ContextButton.SetCheck(1);
	  	m_PhasesButton.SetCheck(1);
	  	m_FireDefaultButton.SetCheck(1);
	  	m_FireUserButton.SetCheck(1);
	  	m_FireWmeButton.SetCheck(1);
	  	m_FirePrefButton.SetCheck(1);
	  	m_WMEsButton.SetCheck(1);
	  	break;
	}	

}
