;;;; -*- Mode: Emacs-Lisp -*-
;;;; 
;;;; $Source: /u/hucka/Projects/Soar/Interface/Src/RCS/sde-site.el,v $
;;;; $Id: sde-site.el,v 0.6 1994/06/08 17:37:29 hucka Exp $
;;;; 
;;;; Description       : Site initialization file for SDE.
;;;; Original author(s): Michael Hucka <hucka@flamingo.eecs.umich.edu>
;;;; Organization      : University of Michigan AI Lab
;;;; 

;; This is a very wrong thing to do to users, but it will have to be this
;; way until I figure out how to get Emacs & SDE to behave better with
;; respect to symbolic links.

(setq find-file-visit-truename t)

;; Temporary inclusion of the NNPSCM conversion utilities.  This will
;; eventually go away in a future release of SDE.

(require 'conversion)

;; Where to send bug reports.  Sites may wish to add local addresses to this,
;; so that when people report bugs, local maintainers see them too and get
;; some idea of how things are going with SDE at their site.  If you place
;; more than one address here, make sure to separate the addresses with
;; commas.

(if (and (boundp 'sde-feedback-address) (null sde-feedback-address))
    (setq sde-feedback-address "sde-bugs@umich.edu")
    (defvar sde-feedback-address "sde-bugs@umich.edu"))

;; Pathname to Soar release notes file.  Set this to the full path of
;; the file "Release.Notes" in the "doc" subdirectory of the Soar system
;; directory at your site.  (Replace the two instances of the value "nil"
;; with the correct pathname.)

(if (and (boundp 'sde-soar-release-notes-file) (null sde-soar-release-notes-file))
    (setq sde-soar-release-notes-file nil)
    (defvar sde-soar-release-notes-file nil))

;; Pathname to Soar release notes file.  Set this to the full path of
;; the file "User.Notes" in the "doc" subdirectory of the Soar system
;; directory at your site. 

(if (and (boundp 'sde-soar-user-notes-file) (null sde-soar-user-notes-file))
    (setq sde-soar-user-notes-file nil)
    (defvar sde-soar-user-notes-file nil))

;; Pathname to the Soar defaults file.  Set this to the full path of
;; the file defaults.soar6 in the newest Soar source directory on your
;; system.

(if (and (boundp 'sde-soar-defaults-file) (null sde-soar-defaults-file))
    (setq sde-soar-defaults-file nil)
    (defvar sde-soar-defaults-file nil))

;; Other things that you may consider setting here:
;;   sde-info-file, the info file for SDE, if that file is not located in
;;   the directory where all the other SDE files are, or if it is not
;;   called by its default name (set in sde.el).
;;
;;   sde-soar-info-file, the on-line Soar manual in info format, if that file
;;   is not called by its default name (set in sde.el).
