

/*
 *	Windows Soar v1.0
 *	GUI code (c) 1993 Price Waterhouse,
 *	Soar 6.1 kernel (c) Carnegie Mellon University
 */

// soar.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "soar.h"

#include "mainfrm.h"
#include "machdoc.h"
#include "cmdfram.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSoarApp

BEGIN_MESSAGE_MAP(CSoarApp, CWinApp)
	//{{AFX_MSG_MAP(CSoarApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
	// Global help commands
	ON_COMMAND(ID_HELP_INDEX, CWinApp::OnHelpIndex)
	ON_COMMAND(ID_HELP_USING, CWinApp::OnHelpUsing)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CWinApp::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CWinApp::OnHelpIndex)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSoarApp construction

CSoarApp::CSoarApp()
{
	m_pSoarMachine=NULL;
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSoarApp object

CSoarApp FAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CSoarApp initialization

BOOL CSoarApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // set dialog background color to gray
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	//AddDocTemplate(new CMultiDocTemplate(IDR_SOARTYPE,
	//		RUNTIME_CLASS(CSoarDoc),
	//		RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
	//		RUNTIME_CLASS(CEditView)));

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	m_pMainWnd = pMainFrame;

	// enable file manager drag/drop and DDE Execute open
	m_pMainWnd->DragAcceptFiles();
	EnableShellOpen();
	RegisterShellFileTypes();

	// simple command line parsing
	if (m_lpCmdLine[0] == '\0')
	{
		// create a new (empty) document
		OnFileNew();
	}
	else if ((m_lpCmdLine[0] == '-' || m_lpCmdLine[0] == '/') &&
		(m_lpCmdLine[1] == 'e' || m_lpCmdLine[1] == 'E'))
	{
		// program launched embedded - wait for DDE or OLE open
	}
	else
	{
		// open an existing document
		OpenDocumentFile(m_lpCmdLine);
	}

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CSoarApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CSoarApp commands

/*
 * Nasty hacks to get the SoarMachine initiqalized and the
 * CommandView up
 */
void CSoarApp::OnFileNew()
{
	if (m_templateList.IsEmpty())
	{
		TRACE0("Error : no document templates registered with CWinApp\n");
		AfxMessageBox(AFX_IDP_FAILED_TO_CREATE_DOC);
		return;
	}   
	

      if (m_pSoarMachine==NULL) {
      CMultiDocTemplate* pTemp;
	  pTemp = new CMultiDocTemplate(IDR_MACHINETYPE,
							RUNTIME_CLASS(CMachineDoc),
							RUNTIME_CLASS(CCommandFrame),  // Command splitter window
							NULL);						   // Since the splitter will take care of it...
	  ASSERT(pTemp != NULL);
	  ASSERT(pTemp->IsKindOf(RUNTIME_CLASS(CDocTemplate)));
	  pTemp->OpenDocumentFile(NULL);
	} else {	
	  CDocTemplate* pTemplate = (CDocTemplate*)m_templateList.GetHead();

	  ASSERT(pTemplate != NULL);
	  ASSERT(pTemplate->IsKindOf(RUNTIME_CLASS(CDocTemplate)));

	  pTemplate->OpenDocumentFile(NULL);
		// if returns NULL, the user has already been alerted
	}
	
}

